'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _commonTags = require('common-tags');

var _config = require('../../config');

var _config2 = _interopRequireDefault(_config);

var _version = require('../../version');

var _version2 = _interopRequireDefault(_version);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

exports.default = {
	name: 'about',
	group: 'general',
	groupName: 'about',
	description: 'Displays information about the bot.',

	isRunnable() {
		return true;
	},

	run(message) {
		return new Promise(function ($return, $error) {
			const owner = message.client.users.get('id', _config2.default.owner);
			const servers = message.client.servers.length.toLocaleString(),
			      users = message.client.users.length.toLocaleString();
			const serversLabel = servers != 1 ? 'servers' : 'server',
			      usersLabel = users != 1 ? 'users' : 'user';
			const uptime = process.uptime();
			const days = Math.floor(uptime / 60 / 60 / 24),
			      hours = Math.floor(uptime / 60 / 60 % 24),
			      minutes = Math.floor(uptime / 60 % 60);
			const daysLabel = days != 1 ? 'days' : 'day',
			      hoursLabel = hours != 1 ? 'hours' : 'hour',
			      minutesLabel = minutes != 1 ? 'minutes' : 'minute';
			const daysStr = `${ days.toLocaleString() } ${ daysLabel }`,
			      hoursStr = `${ hours.toLocaleString() } ${ hoursLabel }`,
			      minutesStr = `${ minutes.toLocaleString() } ${ minutesLabel }`;
			message.client.sendMessage(message.author, _commonTags.stripIndents`
			**RPBot** v${ _version2.default } created by Schuyler Cebulskie (Gawdl3y).
			Source code and information: https://github.com/Gawdl3y/discord-rpbot

			This bot ${ owner ? `is owned by ${ owner.name }#${ owner.discriminator }, and ` : '' }is serving ${ users } ${ usersLabel } across ${ servers } ${ serversLabel }.
			It has been running without interruption for ${ days > 0 ? `${ daysStr } ` : '' }${ hours > 0 ? `${ hoursStr } ` : '' }${ minutesStr }.
			${ _config2.default.invite ? `For bot feedback/help, use this invite: ${ _config2.default.invite }` : '' }
		`);
			if (message.server) message.reply('Sent a DM to you with information.');
			return $return();
		}.$asyncbind(this));
	}
};