'use babel';
'use strict';

/* eslint-disable no-unused-vars */

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

var _diceExpressionEvaluator = require('dice-expression-evaluator');

var _diceExpressionEvaluator2 = _interopRequireDefault(_diceExpressionEvaluator);

var _stringArgv = require('string-argv');

var _stringArgv2 = _interopRequireDefault(_stringArgv);

var _rpbot = require('../../rpbot');

var rpbot = _interopRequireWildcard(_rpbot);

var _config = require('../../config');

var _config2 = _interopRequireDefault(_config);

var _version = require('../../version');

var _version2 = _interopRequireDefault(_version);

var _ = require('..');

var commands = _interopRequireWildcard(_);

var _database = require('../../database');

var _database2 = _interopRequireDefault(_database);

var _localStorage = require('../../database/local-storage');

var _localStorage2 = _interopRequireDefault(_localStorage);

var _character = require('../../database/character');

var _character2 = _interopRequireDefault(_character);

var _setting = require('../../database/setting');

var _setting2 = _interopRequireDefault(_setting);

var _modRole = require('../../database/mod-role');

var _modRole2 = _interopRequireDefault(_modRole);

var _search = require('../../util/search');

var _search2 = _interopRequireDefault(_search);

var _disambiguation = require('../../util/disambiguation');

var _disambiguation2 = _interopRequireDefault(_disambiguation);

var _pagination = require('../../util/pagination');

var _pagination2 = _interopRequireDefault(_pagination);

var _commandPattern = require('../../util/command-pattern');

var _commandPattern2 = _interopRequireDefault(_commandPattern);

var _logger = require('../../util/logger');

var _logger2 = _interopRequireDefault(_logger);

var _updateCheck = require('../../util/update-check');

var _updateCheck2 = _interopRequireDefault(_updateCheck);

var _permissions = require('../../util/permissions');

var permissions = _interopRequireWildcard(_permissions);

var _commandUsage = require('../../util/command-usage');

var usage = _interopRequireWildcard(_commandUsage);

var _nbsp = require('../../util/nbsp');

var nbsp = _interopRequireWildcard(_nbsp);

var _friendly = require('../../util/errors/friendly');

var _friendly2 = _interopRequireDefault(_friendly);

var _commandFormat = require('../../util/errors/command-format');

var _commandFormat2 = _interopRequireDefault(_commandFormat);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

/* eslint-enable no-unused-vars */

exports.default = {
	name: 'eval',
	group: 'general',
	groupName: 'eval',
	description: 'Evaluates input as JavaScript.',
	usage: 'eval <script>',
	details: 'Only the bot owner may use this command.',
	singleArgument: true,

	isRunnable(message) {
		return message.author.id === _config2.default.owner;
	},

	run(msg, args) {
		return new Promise(function ($return, $error) {
			if (!args[0]) return $error(new _commandFormat2.default(this, msg.server));
			try {
				msg.reply(`Result: \`${ _util2.default.inspect(eval(args[0]), { depth: 0 }) }\``);
			} catch (e) {
				msg.reply(`Error while evaluating: ${ e }`);
			}
			return $return();
		}.$asyncbind(this));
	}
};