'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _commonTags = require('common-tags');

var _ = require('..');

var _disambiguation = require('../../util/disambiguation');

var _disambiguation2 = _interopRequireDefault(_disambiguation);

var _commandUsage = require('../../util/command-usage');

var usage = _interopRequireWildcard(_commandUsage);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

exports.default = {
	name: 'help',
	group: 'general',
	groupName: 'help',
	aliases: ['commands'],
	description: 'Displays a list of available commands, or detailed information for a specified command.',
	usage: 'help [command]',
	details: 'The command may be part of a command name or a whole command name. If it isn\'t specified, all available commands will be listed.',
	examples: ['help', 'help roll'],

	isRunnable() {
		return true;
	},

	run(message, args) {
		return new Promise(function ($return, $error) {
			const commands = (0, _.findCommands)(args[0], message);
			if (args[0]) {
				if (commands.length === 1) {
					let help = _commonTags.stripIndents`
					__Command **${ commands[0].name }**:__ ${ commands[0].description }

					**Usage:** ${ usage.long(commands[0].usage ? commands[0].usage : commands[0].name, message.server) }
				`;
					if (commands[0].aliases) help += `\n**Aliases:** ${ commands[0].aliases.join(', ') }`;
					if (commands[0].details) help += `\n**Details:** ${ commands[0].details }`;
					if (commands[0].examples) help += `\n**Examples:**\n${ commands[0].examples.join('\n') }`;
					message.client.sendMessage(message.author, help);
					if (message.server) message.reply('Sent a DM to you with information.');
				} else if (commands.length > 1) {
					message.reply((0, _disambiguation2.default)(commands, 'commands'));
				} else {
					message.reply(`Unable to identify command. Use ${ usage.long('help', message.server) } to view the list of all commands.`);
				}
			} else {
				message.client.sendMessage(message.author, _commonTags.stripIndents`
				${ message.server ? `To run a command in ${ message.server }, use ${ usage.long('command', message.server) }. For example, ${ usage.long('roll d20', message.server) }.` : '' }
				To run a command in this DM, simply use ${ usage.short('command') } with no prefix. For example, ${ usage.short('roll d20') }.

				**Available commands in ${ message.server ? `${ message.server }` : 'this DM' } (use ${ usage.short('help <command>') } for more info):**

				${ _.groups.filter(g => g.commands.some(c => c.isRunnable(message))).map(g => _commonTags.stripIndents`
					__${ g.name }__
					${ g.commands.filter(c => c.isRunnable(message)).map(c => `**${ c.name }:** ${ c.description }`).join('\n') }
				`).join('\n\n') }
			`);
				if (message.server) message.reply('Sent a DM to you with information.');
			}
			return $return();
		}.$asyncbind(this));
	}
};