'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _rpbot = require('../../rpbot');

var _config = require('../../config');

var _config2 = _interopRequireDefault(_config);

var _commandPattern = require('../../util/command-pattern');

var _commandPattern2 = _interopRequireDefault(_commandPattern);

var _permissions = require('../../util/permissions');

var permissions = _interopRequireWildcard(_permissions);

var _commandUsage = require('../../util/command-usage');

var usage = _interopRequireWildcard(_commandUsage);

var _setting = require('../../database/setting');

var _setting2 = _interopRequireDefault(_setting);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

exports.default = {
	name: 'prefix',
	group: 'general',
	groupName: 'prefix',
	description: 'Shows or sets the command prefix.',
	usage: 'prefix [prefix|"default"|"none"]',
	details: 'If no prefix is provided, the current prefix will be shown. If the prefix is "default", the prefix will be reset to the bot\'s default prefix. If the prefix is "none", the prefix will be removed entirely, only allowing mentions to run commands. Only administrators may change the prefix.',
	examples: ['prefix', 'prefix -', 'prefix rp!', 'prefix default', 'prefix none'],
	singleArgument: true,

	isRunnable() {
		return true;
	},

	run(message, args) {
		return new Promise(function ($return, $error) {
			if (args[0] && message.server) {
				// Only allow administrators
				if (!permissions.isAdministrator(message.server, message.author)) {
					message.reply('Only administrators may change the command prefix.');
					return $return();
				}

				// Save the prefix
				const lowercase = args[0].toLowerCase();
				const prefix = lowercase === 'none' ? '' : args[0];
				let response;
				if (lowercase === 'default') {
					_setting2.default.delete('command-prefix', message.server);
					response = `Reset the command prefix to default (currently "${ _config2.default.commandPrefix }").`;
				} else {
					_setting2.default.save(new _setting2.default(message.server, 'command-prefix', prefix));
					response = prefix ? `Set the command prefix to "${ args[0] }".` : 'Removed the command prefix entirely.';
				}

				// Build the pattern
				const pattern = (0, _commandPattern2.default)(message.server, _rpbot.client.user);
				_rpbot.serverCommandPatterns[message.server.id] = pattern;

				message.reply(`${ response } To run commands, use ${ usage.long('command', message.server) }.`);
			} else {
				const prefix = message.server ? _setting2.default.getValue('command-prefix', _config2.default.commandPrefix, message.server) : _config2.default.commandPrefix;
				message.reply(`${ prefix ? `The command prefix is "${ prefix }".` : 'There is no command prefix.' } To run commands, use ${ usage.long('command', message.server) }.`);
			}
			return $return();
		}.$asyncbind(this));
	}
};