'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.groups = exports.commands = undefined;
exports.findCommands = findCommands;

var _help = require('./general/help');

var _help2 = _interopRequireDefault(_help);

var _about = require('./general/about');

var _about2 = _interopRequireDefault(_about);

var _listRoles = require('./general/list-roles');

var _listRoles2 = _interopRequireDefault(_listRoles);

var _prefix = require('./general/prefix');

var _prefix2 = _interopRequireDefault(_prefix);

var _eval = require('./general/eval');

var _eval2 = _interopRequireDefault(_eval);

var _roll = require('./dice/roll');

var _roll2 = _interopRequireDefault(_roll);

var _max = require('./dice/max');

var _max2 = _interopRequireDefault(_max);

var _min = require('./dice/min');

var _min2 = _interopRequireDefault(_min);

var _view = require('./characters/view');

var _view2 = _interopRequireDefault(_view);

var _list = require('./characters/list');

var _list2 = _interopRequireDefault(_list);

var _add = require('./characters/add');

var _add2 = _interopRequireDefault(_add);

var _delete = require('./characters/delete');

var _delete2 = _interopRequireDefault(_delete);

var _list3 = require('./mod-roles/list');

var _list4 = _interopRequireDefault(_list3);

var _add3 = require('./mod-roles/add');

var _add4 = _interopRequireDefault(_add3);

var _delete3 = require('./mod-roles/delete');

var _delete4 = _interopRequireDefault(_delete3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

const commands = exports.commands = [_help2.default, _about2.default, _listRoles2.default, _prefix2.default, _eval2.default, _roll2.default, _max2.default, _min2.default, _view2.default, _list2.default, _add2.default, _delete2.default, _list4.default, _add4.default, _delete4.default];
exports.default = commands;
const groups = exports.groups = [{ id: 'general', name: 'General', commands: [] }, { id: 'dice', name: 'Dice', commands: [] }, { id: 'characters', name: 'Characters', commands: [] }, { id: 'mod-roles', name: 'Mod roles', commands: [] }];
for (const command of commands) groups.find(g => g.id === command.group).commands.push(command);

function findCommands(searchString = null, message = null) {
	if (!searchString) return message ? commands.filter(c => c.isRunnable(message)) : commands;

	// Find all matches
	const lowercaseSearch = searchString.toLowerCase();
	const matchedCommands = commands.filter(c => c.name.includes(lowercaseSearch) || c.aliases && c.aliases.some(a => a.includes(lowercaseSearch)));

	// See if there's an exact match
	for (const command of matchedCommands) {
		if (command.name === lowercaseSearch || command.aliases && command.aliases.some(a => a === lowercaseSearch)) return [command];
	}

	return message ? matchedCommands.filter(c => c.isRunnable(message)) : matchedCommands;
}