'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _modRole = require('../../database/mod-role');

var _modRole2 = _interopRequireDefault(_modRole);

var _disambiguation = require('../../util/disambiguation');

var _disambiguation2 = _interopRequireDefault(_disambiguation);

var _commandUsage = require('../../util/command-usage');

var usage = _interopRequireWildcard(_commandUsage);

var _permissions = require('../../util/permissions');

var permissions = _interopRequireWildcard(_permissions);

var _commandFormat = require('../../util/errors/command-format');

var _commandFormat2 = _interopRequireDefault(_commandFormat);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

const pattern = /^(?:<@&)?(.+?)>?$/;

exports.default = {
	name: 'deletemodrole',
	aliases: ['removemodrole', 'delmodrole', 'removemod', 'deletemod', 'delmod'],
	group: 'mod-roles',
	groupName: 'delete',
	description: 'Deletes a moderator role.',
	usage: 'deletemodrole <role>',
	details: 'The role must be the ID of a role, or a role mention. Only administrators may use this command.',
	examples: ['deletemodrole cool', 'deletemodrole 205536402341888001', 'deletemodrole @CoolPeopleRole'],
	singleArgument: true,

	isRunnable(message) {
		return message.server && permissions.isAdministrator(message.server, message.author);
	},

	run(message, args) {
		return new Promise(function ($return, $error) {
			if (!args[0]) return $error(new _commandFormat2.default(this, message.server));
			const matches = pattern.exec(args[0]);
			let roles;
			const idRole = message.server.roles.get('id', matches[1]);
			if (idRole) roles = [idRole];else roles = _modRole2.default.findInServer(message.server, matches[1]);

			if (roles.length === 1) {
				if (_modRole2.default.delete(roles[0])) {
					message.reply(`Removed "${ roles[0].name }" from the moderator roles.`);
				} else {
					message.reply(`Unable to remove "${ roles[0].name }" from the moderator roles. It isn\'t one.`);
				}
			} else if (roles.length > 1) {
				message.reply((0, _disambiguation2.default)(roles, 'roles'));
			} else {
				message.reply(`Unable to identify role. Use ${ usage.long('modroles', message.server) } to view the the moderator roles, and ${ usage.long('roles', message.server) } to view all of the server roles.`);
			}
			return $return();
		}.$asyncbind(this));
	}
};