'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _jsYaml = require('js-yaml');

var _jsYaml2 = _interopRequireDefault(_jsYaml);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _version = require('./version');

var _version2 = _interopRequireDefault(_version);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

const config = _yargs2.default.usage('$0 [command] [options]').example('$0 --token SomeAPITokenGoesHere', 'Starts the bot using a token').example('$0 --email SomeGuy@SomeSite.com --password SomeCrazyPassword123', 'Starts the bot using an email and password').example('$0 --config settings.yml', 'Starts the bot using a config file').example('$0 completion', 'Outputs Bash completion script').epilogue(`RPBot v${ _version2.default } by Schuyler Cebulskie (Gawdl3y): https://github.com/Gawdl3y/discord-rpbot/`)

// Authentication
.option('token', {
	type: 'string',
	alias: 't',
	describe: 'API token for the bot account',
	group: 'Authentication:'
}).option('email', {
	type: 'string',
	alias: 'e',
	describe: 'Email of the Discord account for the bot to use',
	group: 'Authentication:'
}).option('password', {
	type: 'string',
	alias: 'p',
	describe: 'Password of the Discord account for the bot to use',
	group: 'Authentication:'
}).implies({ email: 'password', password: 'email' })

// Database
.option('database', {
	type: 'string',
	default: 'rpbot.sqlite3',
	alias: 'd',
	describe: 'Path to SQLite3 database file',
	group: 'Database:',
	normalize: true
}).option('database-verbose', {
	type: 'boolean',
	alias: 'V',
	describe: 'Whether or not SQLite3 should be put into verbose mode',
	group: 'Database:'
}).option('storage', {
	type: 'string',
	default: 'rpbot-storage',
	alias: 's',
	describe: 'Path to storage directory',
	group: 'Database:',
	normalize: true
})

// General
.option('owner', {
	type: 'string',
	alias: 'o',
	describe: 'Discord user ID of the bot owner',
	group: 'General:'
}).option('invite', {
	type: 'string',
	alias: 'i',
	describe: 'Discord instant invite to contact the owner',
	group: 'General:'
}).option('command-prefix', {
	type: 'string',
	default: '!',
	alias: 'P',
	describe: 'Default command prefix (blank to use only mentions)',
	group: 'General:'
}).option('unknown-only-mention', {
	type: 'boolean',
	alias: 'M',
	describe: 'Whether or not to output unknown command response only for mentions',
	group: 'General:'
}).option('pagination-items', {
	type: 'number',
	default: 15,
	alias: 'I',
	describe: 'Number of items per page in paginated commands',
	group: 'General:'
}).option('update-check', {
	type: 'number',
	default: 60,
	alias: 'U',
	describe: 'How frequently to check for an update (in minutes, use 0 to disable)',
	group: 'General:'
}).option('analytics', {
	type: 'boolean',
	default: true,
	alias: 'A',
	describe: 'Whether or not to enable anonymous, non-unique, non-identifiable analytics',
	group: 'General:'
}).option('auto-reconnect', {
	type: 'boolean',
	default: true,
	alias: 'a',
	describe: 'Whether or not the bot should automatically reconnect when disconnected',
	group: 'General:'
})

// Logging
.option('log', {
	type: 'string',
	default: 'rpbot.log',
	alias: 'l',
	describe: 'Path to log file',
	group: 'Logging:',
	normalize: true
}).option('log-max-size', {
	type: 'number',
	default: 5242880,
	defaultDescription: '5MB',
	alias: 'S',
	describe: 'Maximum size of single log file (in bytes)',
	group: 'Logging:'
}).option('log-max-files', {
	type: 'number',
	default: 5,
	alias: 'F',
	describe: 'Maximum amount of log files to keep',
	group: 'Logging:'
}).option('log-level', {
	type: 'string',
	default: 'info',
	alias: 'L',
	describe: 'Log level to output to the log file (error, warn, info, verbose, debug)',
	group: 'Logging:'
}).option('console-level', {
	type: 'string',
	default: 'info',
	alias: 'C',
	describe: 'Log level to output to the console (error, warn, info, verbose, debug)',
	group: 'Logging:'
})

// General yargs
.option('config', {
	type: 'string',
	alias: 'c',
	describe: 'Path to JSON/YAML config file',
	group: 'Special:',
	normalize: true,
	config: true,
	configParser: configFile => {
		const extension = _path2.default.extname(configFile).toLowerCase();
		if (extension === '.json') return JSON.parse(_fs2.default.readFileSync(configFile));else if (extension === '.yml' || extension === '.yaml') return _jsYaml2.default.safeLoad(_fs2.default.readFileSync(configFile));
		throw new Error('Unknown config file type.');
	}
}).help().alias('help', 'h').group('help', 'Special:').version(_version2.default).alias('version', 'v').group('version', 'Special:').completion('completion').wrap(_yargs2.default.terminalWidth()).argv;

exports.default = config;