'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _ = require('./');

var _2 = _interopRequireDefault(_);

var _localStorage = require('./local-storage');

var _localStorage2 = _interopRequireDefault(_localStorage);

var _search = require('../util/search');

var _search2 = _interopRequireDefault(_search);

var _logger = require('../util/logger');

var _logger2 = _interopRequireDefault(_logger);

var _permissions = require('../util/permissions');

var permissions = _interopRequireWildcard(_permissions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

var sqlFindByServer, sqlFindByServerAndName, sqlFindByServerAndNameLike, sqlInsert, sqlUpdate, sqlDelete;
sqlFindByServer = 'SELECT * FROM characters WHERE server_id = ?';
sqlFindByServerAndName = 'SELECT * FROM characters WHERE server_id = ? AND name = ?';
sqlFindByServerAndNameLike = 'SELECT * FROM characters WHERE server_id = ? AND name LIKE ?';
sqlInsert = 'INSERT INTO characters VALUES(?, ?, ?, ?)';
sqlUpdate = 'UPDATE characters SET name = ?, info = ? WHERE server_id = ? AND name = ?';
sqlDelete = 'DELETE FROM characters WHERE server_id = ? AND name = ?';
class Character {
	constructor(server, owner, name, info) {
		if (!server || !owner || !name) throw new Error('Character name, owner, and server must be specified.');
		this.server = server.id ? server.id : server;
		this.owner = owner.id ? owner.id : owner;
		this.name = name;
		this.info = info;
	}

	static save(character) {
		return new Promise(function ($return, $error) {
			var findStmt, existingCharacters, updateStmt, insertStmt;

			if (!character) return $error(new Error('A character must be specified.'));
			return _2.default.prepare(sqlFindByServerAndName).then(function ($await_6) {
				findStmt = $await_6;
				return findStmt.all(character.server, character.name).then(function ($await_7) {
					existingCharacters = $await_7;

					findStmt.finalize();
					if (existingCharacters.length > 1) return $error(new Error('Multiple existing characters found.'));

					function $IfStatement_1() {
						return $return();
					}

					if (existingCharacters.length === 1) {
						if (existingCharacters[0].user_id === character.owner || permissions.isModerator(character.server, character.owner)) {
							return _2.default.prepare(sqlUpdate).then(function ($await_8) {
								updateStmt = $await_8;
								return updateStmt.run(character.name, character.info, character.server, existingCharacters[0].name).then(function ($await_9) {
									updateStmt.finalize();
									_logger2.default.info('Updated existing character.', character);
									return $return({ character: new Character(character.server, existingCharacters[0].user_id, character.name, character.info), new: false });
								}.$asyncbind(this, $error), $error);
							}.$asyncbind(this, $error), $error);
						} else {
							return $error(new Error('Character already exists, and the owners don\'t match.'));
						}
						return $IfStatement_1.call(this);
					} else {
						return _2.default.prepare(sqlInsert).then(function ($await_10) {
							insertStmt = $await_10;
							return insertStmt.run(character.server, character.name, character.info, character.owner).then(function ($await_11) {
								insertStmt.finalize();
								_logger2.default.info('Added new character.', character);
								return $return({ character: character, new: true });
							}.$asyncbind(this, $error), $error);
						}.$asyncbind(this, $error), $error);
					}
					return $IfStatement_1.call(this);
				}.$asyncbind(this, $error), $error);
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	static delete(character) {
		return new Promise(function ($return, $error) {
			var findStmt, existingCharacters, deleteStmt;

			if (!character) return $error(new Error('A character must be specified.'));
			return _2.default.prepare(sqlFindByServerAndName).then(function ($await_12) {
				findStmt = $await_12;
				return findStmt.all(character.server, character.name).then(function ($await_13) {
					existingCharacters = $await_13;

					findStmt.finalize();
					if (existingCharacters.length > 1) return $error(new Error('Multiple existing characters found.'));

					function $IfStatement_3() {
						return $return();
					}

					if (existingCharacters.length === 1) {
						if (existingCharacters[0].user_id === character.owner || permissions.isModerator(character.server, character.owner)) {
							return _2.default.prepare(sqlDelete).then(function ($await_14) {
								deleteStmt = $await_14;
								return deleteStmt.run(character.server, character.name).then(function ($await_15) {
									deleteStmt.finalize();
									_logger2.default.info('Deleted character.', character);
									return $return(true);
								}.$asyncbind(this, $error), $error);
							}.$asyncbind(this, $error), $error);
						} else {
							return $error(new Error('Existing character is not owned by the specified character owner.'));
						}
						return $IfStatement_3.call(this);
					} else {
						return $error(new Error('Character doesn\'t exist.'));
					}
					return $IfStatement_3.call(this);
				}.$asyncbind(this, $error), $error);
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	static findInServer(server, searchString = null, searchExact = true) {
		return new Promise(function ($return, $error) {
			var findStmt, characters;

			if (!server) return $error(new Error('A server must be specified.'));
			server = server.id ? server.id : server;
			return _2.default.prepare(searchString ? sqlFindByServerAndNameLike : sqlFindByServer).then(function ($await_16) {
				findStmt = $await_16;
				return findStmt.all(server, searchString ? searchString.length > 1 ? `%${ searchString }%` : `${ searchString }%` : undefined).then(function ($await_17) {
					characters = $await_17;

					findStmt.finalize();
					for (const [index, character] of characters.entries()) characters[index] = new Character(character.server_id, character.user_id, character.name, character.info);
					return $return(searchExact ? (0, _search2.default)(characters, searchString, { searchInexact: false }) : characters);
				}.$asyncbind(this, $error), $error);
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}

	static convertStorage() {
		return new Promise(function ($return, $error) {
			var storageEntry, baseMap, keys, characters, serverCharacters, stmt;
			storageEntry = _localStorage2.default.getItem('characters');

			if (!storageEntry) return $return();
			baseMap = JSON.parse(storageEntry);

			if (!baseMap) return $return();
			keys = Object.keys(baseMap);

			if (keys.length === 0) return $return();
			characters = [];

			for (const key of keys) {
				serverCharacters = baseMap[key];

				if (!serverCharacters || serverCharacters.length === 0) continue;
				characters.push(...serverCharacters);
			}

			function $IfStatement_5() {
				_localStorage2.default.removeItem('characters');
				_logger2.default.info('Converted characters from local storage to database.', { count: characters.length });
				return $return();
			}

			if (characters.length > 0) {
				return _2.default.prepare(sqlInsert).then(function ($await_18) {
					stmt = $await_18;

					for (const character of characters) {
						stmt.run(character.server, character.name, character.info, character.owner);
					}
					stmt.finalize();
					return $IfStatement_5.call(this);
				}.$asyncbind(this, $error), $error);
			}return $IfStatement_5.call(this);
		}.$asyncbind(this));
	}
}
exports.default = Character;