'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = checkForUpdate;

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

var _rpbot = require('../rpbot');

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _version = require('../version');

var _version2 = _interopRequireDefault(_version);

var _setting = require('../database/setting');

var _setting2 = _interopRequireDefault(_setting);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

const packageURL = 'https://raw.githubusercontent.com/Gawdl3y/discord-rpbot/master/package.json';

function checkForUpdate() {
	(0, _request2.default)(packageURL, (error, response, body) => {
		if (!error && response.statusCode == 200) {
			const masterVersion = JSON.parse(body).version;
			if (_semver2.default.gt(masterVersion, _version2.default)) {
				const message = `An RPBot update is available! Current version is ${ _version2.default }, latest available is ${ masterVersion }.`;
				_logger2.default.warn(message);
				const savedVersion = _setting2.default.getValue('notified-version');
				if (savedVersion != masterVersion && _rpbot.client && _config2.default.owner) {
					_rpbot.client.sendMessage(_config2.default.owner, message);
					_setting2.default.save(new _setting2.default(null, 'notified-version', masterVersion));
				}
			}
		}
	});
}