'use babel';
'use strict';

import ModRole from '../../database/mod-role';
import * as permissions from '../../util/permissions';

export default {
	name: 'modroles',
	aliases: ['listmodroles', 'mods'],
	group: 'mod-roles',
	groupName: 'list',
	description: 'Lists all moderator roles.',
	details: 'Only administrators may use this command.',

	isRunnable(message) {
		return message.server && permissions.isAdministrator(message.server, message.author);
	},

	async run(message) {
		const roles = ModRole.findInServer(message.server);
		if(roles.length > 0) {
			message.reply('__**Moderator roles:**__\n' + roles.map(role => `${role.name} (ID: ${role.id})`).join('\n'));
		} else {
			message.reply('There are no moderator roles.');
		}
	}
};
